
%m-file: ex5_3_1
v=0.5*(rand(1,20)-0.5);%v=noise vector(20 uniformly distributed rvs 
    %with mean zero);
x=randn(1,20);% x=data vector entering the system and the Wiener 
    %filter (20 normal distributed rvs with mean zero;   
sysout=filter([1 0.38],1,x);% sysout=system output with x as input; 
    %filter(b,a,x) is a
    %MATLAB function, where b is the vector of the 
    %coefficients of the ARMA numerator,
    % a is the vector of the coefficients of the 
    %ARMA denominator (see (2.4.7);
dn=sysout+v;
rx1=xcorr(x,2,'biased');
rx=rx1(1,3:4);
Rx=toeplitz(rx);%toeplitz() is a MATLAB function that
                % gives the symmetric
                % autocorrelation matrix;
pdx=xcorr(x,dn,2,'biased');%xcorr() a MATLAB function that 
                %gives a symmetric biased crosscorrelation;
p=pdx(1,2:3);
w=inv(Rx)*p';
dnsig1=xcorr(dn,1,'biased');
dnsig=dnsig1(2);
jmin=dnsig-p*w;

