
function[y,a]=ssp_covariance_methodpsd(p,N)
%p=order of the AR filter for the PSD estimate;
%N=the number of IIIR output and signal length;
%y=signal and IIR output combined;a is a vector
%of the AR coefficients;
for m=0:N-1
y1(1)=0;y1(2)=0;y1(3)=0;y1(4)=0;
y1(m+5)=1.3847*y1(m+4)-1.5602*y1(m+3)+0.8883*y1(m+2)...
    -0.4266*y1(m+1)+randn;
s(m+1)=3*sin(0.3*pi*m)+3*sin(0.33*pi*m)+2*sin(0.6*pi*m);
end;
y=y1(1,5:length(y1))+s;
for t=0:-p+N-1
    yv(t+1)=y(t+p+1);
end;
for r=0:N-p-1
    for q=0:p-1
    Y(r+1,q+1)=y(1,p+r-q);
end;
end;
a=-(inv(Y'*Y))*(Y'*yv');

