
function[psd,v,d,R]=ssp_eigen_vector_alg(x,p,M,nfft)
%length(x)+M<2*length(x);R=correlation matrix;
%p=number of sinusoids; M=time window; nfft=the desired
%number of bins in fft e.g. 256 or 512;
%to observe the spectrum write plot(psd/max(psd));
r=xcorr(x,'biased');
R=toeplitz(r(:,length(x):length(x)+M));
[v,d]=eig(R);
[y,i]=sort(diag(d));
for j=1:M-p
    V=[V,v(:,i(j))];
end;
a=V*V(1,:)';
psd=abs(fft(a,nfft));
