
function[x1,a1,xe1,x2,a2,xe2,xe1f,xe2f]=ssp_extrap_psd_meth(x,seg1,seg2,p)
%r=autocorrelation of x;seg1=length of first segment;seg2=length
%of the second segment (se fig 2);length(x)=2^n;p=filter order;
figure(1);plot(x,'k');xlabel('n');ylabel('x(n)');
xx12=[x(1,1:seg1) zeros(1,(length(x)-seg1-seg2)) x(1,(length(x)-seg2+1):length(x))];
figure(2);plot(xx12,'k');xlabel('n');ylabel('Segm. x(n)');
%-------------------------
%Spectrum of the complete sample and segment samples;
w=0:2*pi/256:2*pi-(2*pi/256);
fx=fft(x,256);
figure(3);plot(w,abs(fx)/max(abs(fx)),'k');
xlabel('\omega rad/unit');ylabel('PSD of x(n)');
fxs=fft(xx12,256);
figure(4);plot(w,abs(fxs)/max(abs(fxs)),'k');
xlabel('\omega rad/unit');ylabel('PSD of segm. x(n)');
%--------------------------
%Extrapolation
r1=xcorr(x(1,1:seg1),'biased');
rs1=r1(1,seg1:2*seg1-1);%p<length(rs1);
x1=x(1,1:seg1);
[a1,var1]=ssp_yule_walker_alg_rp(rs1,p);
Ext1=length(x)-seg1-seg2;
for m=1:Ext1
    x1(seg1+m)=-sum(a1'.*fliplr(x1(1,seg1-p+m:seg1-1+m)));
end;
%x1=length(x)-seg2;
xe1=[x1 x(1,length(x)+1:length(x))];
r2=xcorr(x(1,length(x)-seg2:length(x)));
rs2=r2(1,seg2:2*seg2-1);
[a2,var2]=ssp_yule_walker_alg_rp(rs2,p);
%the above p can change to p1 if different number of a's
%is desired; p<min{rs1,rs2};
Ext2=length(x)-seg1-seg2;
for k=1:Ext2
    x2(length(x)-seg2+1-k)=-sum((a2/max(a2))'.*x(1,length(x)-seg2...
        +2-k:length(x)-seg2+1+p-k));
end;
xe2=[x(1,1:length(x)-seg1-seg2) x2(length(x)-seg1-seg2+1:length(x)...
    -seg2) x(1,length(x)-seg2+1:length(x))];
figure(5)
xe1f=(abs(fft(xe1,256))/max(abs(fft(xe1,256))));
plot(w,xe1f,'k');xlabel('\omega rad/unit');ylabel('PSD of ext1');
figure(6);
xe2f=(abs(fft(xe2,256))/max(abs(fft(xe2,256))));
plot(w,xe2f,'k');xlabel('\omega rad/unit');ylabel('PSD ext2');













