

function[w,y,e,J,w1]=ssp_lms_error_data_sign_sign(x,dn,mu,M,al,ga)
%function[w,y,e,j,w1]=ssp_lms_error_data_sign_sign(x,dn,mu,M,al,ga);
%all quantities are real; x=input data to the filter;
%dn=desired signal;M=filter order;mu=step size;x and dn must have the 
%same length;0<al<1; ga=1-al, or diferent value less than one;
N=length(x);
y=zeros(1,N);
w=zeros(1,M);%initialization;
en=0;
for n=M:N
    x1=x(n:-1:n-M+1);
    y(n)=w*x1';
    e(n)=dn(n)-y(n);
    en=en+(abs(e(n)))^2;
    w=w+2*mu*en*(sign(e(n))*sign(x1))/(al*en+ga*x1*x1');
    w1(n-M+1,:)=w(1,:);
end;
J=e.^2;
%columns of w1 depict the history of the filter coefficients;

