

function[s,as,ps]=sspperiodogram(x,L)
%[s,as,ps]=sspperiodogram(x,L)
%L=desired number of points (bins) of the spectrum;
%x=data in row form; s=complex form of the DFT;
%the directory sspdata.mat contains the file ch3-data1 which
%contains ten thousand elements of two sine signals, a normal
%noise sequence and the signal x of the sum of the three signals;
for m=1:L
    n=1:length(x);
    s(m)=sum(x.*exp(-j*(m-1)*(2*pi/L)*n));
end;
as=((abs(s)).^2/length(x));%as=amplitude spectral density;
ps=(atan(imag(s)./real(s))/length(x));%ps=phase spectrum;
  
%To plot as or ps we can use the command:
%plot(0:2*pi/L:2*pi-(2*pi/L),as);for the phase spectrum
%we change as to ps;

