
%normal histogram m-File: normal_hist
n=1000;
x=1.5*randn(1,n)+6*ones(1,n);
subplot(1,2,1);plot(x(1,1:200),'k');
xlabel('n');ylabel('x(n)');grid on;
[m,z]=hist(x,10); %calculates counts in bins
               %and bin coordinates for 20 bins;
w=max(x)/length(z);   %calculates bin width;
pb=m/(n*w);    %probability in each bin;
v=linspace(min(x),max(x));%generates 100 values over 
               %range of rv x;
y=(1/(2*sqrt(2*pi)))*exp(-((v-6*ones(size(v))).^2)/4.5);
               %normal pdf;
subplot(1,2,2);
colormap([1 1 1]);%creates white bars, for other colors
                  % see >>help colormap;
bar(z,pb); %plots histogram;
hold on;plot(v,y,'k')%superimpose plot of normal pdf;
xlabel('RV value');ylabel('Probability density');