
function[arft,w,r,a]=sspARpsd1(x,lg,ord,L)
%x=output of an IIR with input white Gaussian
%noise of variance 1 and mean zero;a(ord)=coefficients
%with order equal to ord;lg=number of lags for the autocorralation
%function and MUST be at least one larger than the ord;
%ord=order of the AR model; L=desired bins in the spectrum;
%on the command window the plot(w,arft) will plot the PSD;
r=sasamplebiasedautoc(x,lg);
m=1:ord;
R=toeplitz(r(1,1:ord));
a=-inv(R)*r(1,2:ord+1)';
w=0:2*pi/L:2*pi-(2*pi/L);
arft=(1./abs((1+(exp(-j*w'*m)*a)).^2))/lg;