
function[w,y,e,J,dd,n,Mpercent]=ssp_error_normalized_step_size(I,LL,mu1)
%NN=length of the error vector e sub L;mu1=step size;
%N=length of adaptive filter;
%I=number of independent simulations runs used to average 
%the learning curv;
%LL=total number of iterations;
%h=the impulse response of an unknown system(plant);
%x=input to the unknown system and adaptive filter;
%dd=output of the unknown plant used as the desired signal;
%y=output of the adaptive filter;
%n=the internal noise of the unknown system;
%J=the MSE;

J=zeros(1,LL);Jminn=zeros(1,LL);
N=4;NN=10*N; h=[1 0.72 0.5 -0.21];
J=zeros(1,LL);Jex=zeros(1,LL);
for i=1:I
    X=zeros(N,1);D=zeros(NN,1);y=zeros(1,LL);
    x=randn(1,LL);w=zeros(1,N);e=zeros(1,LL);
    denn=0;n=sqrt(0.09)*(randn(1,LL));
    
    for k=1:LL
        dd=filter(h,1,x);
        X=[x(k);X(1:N-1)];den=X'*X;y(k)=w*X;
        e(k)=dd(k)+n(k)-y(k);
        denn=denn+e(k)^2;mu=(mu1/(1+mu1*denn));
        w=w+mu*e(k)*X';
        J(k)=J(k)+(abs(e(k)))^2;
        Jminn(k)=Jminn(k)+n(k)^2;
    end;
end;
J=J/I;Jmin1=Jminn/I;Jmin=sum(Jmin1)/LL;Jex=J-Jmin;
Jinf=(1/I)*sum(J(LL-I-1:LL));JSSdB=10*log10(Jinf);
Jexinf=abs(Jinf-Jmin);JexinfSSdB=10*log10(Jexinf);
MM=Jexinf/Jmin;Mpercent=MM*100;

