
function[psd,q,d,R]=ssp_music_alg(x,p,M,nfft)
%length(x)+M<2*length(x); R=correlation matrix;
%p=number of sinusoids; M=time window;nfft=the
%desired number of bins in fft e.g. 256 or 512;
%to observe the spectrum write plot(psd/max(psd));
r=xcorr(x,'biased');
R=toeplitz(r(:,length(x):length(x)+M));
[q,d]=eig(R);
qin=zeros(nfft,1);
for i=1:M-p-1
    qin=qin+abs(fft(q(:,i),nfft));
end;
psd=1./(qin/max(qin));
