
%Book MATLAB m-file:sspmod_bartlett_psd
n=0:63;
x=sin(0.3*pi*n)+sin(0.325*pi*n)+0.6*randn(1,64);
[s,as,ps]=sspbartlettpsd(x,1,128);%
[s1,as1,ps1]=sspbartlettpsd(x,2,128);
[s2,as2,ps2]=sspbartlettpsd(x,2,128);
x1=[0.3*x   0.3*x+0.5*rand(1,64)];
[s2,as2,ps2]=sspbartlettpsd(x1,2,128);
w=0:2*pi/128:2*pi-(2*pi/128);
subplot(3,1,1);plot(w,(abs(as)/max(abs(as))),'k');
xlabel('Freq. per unit');ylabel('Magnitude');
title('PSD of 64-term sequence')
subplot(3,1,2);plot(w,(abs(as1)/max(abs(as1))),'k');
xlabel('Freq. per unit');ylabel('Magnitude');
title('PSD of two subsamples of the above sequence');
subplot(3,1,3);plot(w,(abs(as2)/max(abs(as2))),'k');
xlabel('Freq. per unit');ylabel('Magnitude');
title('PSD of two subsamples of the modified sequence');
