
function[s,as,ps]=sspperiodogramwin(x,win,L)
%[s,as,ps]=sspperiodogram(x,win,L)
%window names=hamming,kaiser,hann,rectwin,
%bartlett,tukeywin,blackman,gausswin,nattallwin,triang,blackmanharris;
%L=desired number of points (bins) of the spectrum;
%x=data in row form;s=complex form of the DFT;
if (win==2) w=rectwin(length(x));
elseif (win==3) w=hamming(length(x));
elseif (win==4) w=bartlett(length(x));
elseif (win==5) w=tukeywin(length(x));
elseif (win==6) w=blackman(length(x));
elseif (win==7) w=triang(length(x));
elseif (win==8) w=blackmanharris(length(x));
end;
xw=x.*w';
for m=1:L
    n=1:length(x);
    s(m)=sum(xw.*exp(-j*(m-1)*(2*pi/L)*n));
end;
as=((abs(s)).^2/length(x))/norm(w);%as=amplitude spectral density;
ps=(atan(imag(s)./real(s))/length(x))/norm(w);%ps=phase spectrum;
  
%To plot as or ps we can use the command: plot(0:2*pi/L:2*pi-(2*pi/L),as);

