
function[w,jm]=sspwieneridentif(x,d,M)
%function[w,jm]=sspwieneridentif(x,d,M);
%x=data entering both the unknown filter
%(system) and the Wiener filter;
%d=the desired signal=output of the unknown system;
%length(d)=length(x);
%M=number of coefficients of the Wiener filter;
%w=Wiener filter coefficients equal to M+1;
%jm=minimum mean square error; 
pdx=xcorr(d,x,M,'biased');
p=pdx(1,M+1:2*M+1);
rx1=xcorr(x,M,'biased');
rx=rx1(1,M+1:2*M+1);
R=toeplitz(rx);
w=inv(R)*p';
jm=var(d)-p*w;% var() is a MATLAB function;
